#include <fstream>
#include <cstring>
#include <iostream>
using namespace std;

const int MAXP = 10;
const int MAXA = 5;
const int MAXS = 100;
const int MAXR = 30;

enum Attivita {TENNIS, CALCIO, WINDSURF, BALLO, PALESTRA};

struct Resort {
  char nome[MAXS];
  char luogo[MAXS];
  Attivita att[MAXA];
  int quanteAtt;
  float costoAdulto;
  float costoBambino;
  int etaMaxBambino;
  int disponibilita;
};

struct Richiesta {
  int quanteP;
  int eta[MAXP];
  float budget;
  char luogo[MAXS];
};

struct AgenziaViaggi {
  Resort resorts[MAXR];
  int quanti;
};


int carica(AgenziaViaggi* pa, const char fn[]);
void stampaResortCompatibili(const AgenziaViaggi* pa, Richiesta r);
int cercaPerAttivita(const AgenziaViaggi* pa, Attivita a, Resort vett[]);
void stampaOrd(const AgenziaViaggi* pa);
bool prenota(AgenziaViaggi* pa, const char n[], int q);

void stampaResort(Resort r) {
  cout << r.nome << '\t' << r.luogo << '\n' << r.costoAdulto << '\t' << r.costoBambino 
       << '\t' << r.etaMaxBambino << '\t' << r.disponibilita << '\t';
  for(int i=0; i<r.quanteAtt; i++)
    switch(r.att[i]) {
      case TENNIS: cout << 't';
        break;
      case CALCIO: cout << 'c';
        break;
      case WINDSURF: cout << 'w';
        break;
      case BALLO: cout << 'b';
        break;
      case PALESTRA: cout << 'p';
        break;
    }
    cout << "\n------------------------" << endl;
}

void menu(){
  cout << endl << endl;
  cout << "1) carica" << endl;
  cout << "2) stampa resort compatibili" << endl;
  cout << "3) cerca per attivita`" << endl;
  cout << "4) stampa ordinata" << endl;
  cout << "5) prenota" << endl;
  cout << "6) esci" << endl;
  cout << "? ";
}

Richiesta leggiRichiesta(){
  Richiesta r;
  cout << "Luogo? ";
  cin >> r.luogo;
  cout << "Budget? ";
  cin >> r.budget;
  cout << "Quante persone? ";
  cin >> r.quanteP; 
  for(int i=0; i<r.quanteP; i++) {
    cout << "Eta persona? ";
    cin >> r.eta[i];
  } 
  return r;
}

Attivita leggiAttivita(){
  cout << "Inserisci t, c, w, b, oppure p: ";
  char c;
  cin >> c;
  do {
    switch(c){
      case 't': return TENNIS;
      case 'c': return CALCIO;
      case 'w': return WINDSURF;
      case 'b': return BALLO;
      case 'p': return PALESTRA;
      default:
        cout << "Scelta non valida" << endl;
    }
  } while(true);
}

int main(){
  AgenziaViaggi ag;
  ag.quanti = 0;

  char c;
  bool ris;
  int x;
  Richiesta r;
  Attivita a;
  Resort v[MAXR];
  char n[MAXS];
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        x = carica(&ag, "input.txt");
        cout << "Ho caricato i dati di " << x << " resort" << endl;
        break;
      case '2':
        r = leggiRichiesta();
        cout << "Resort compatibili: " << endl;
        stampaResortCompatibili(&ag, r);  
        break;
      case '3':
        a = leggiAttivita();
        x = cercaPerAttivita(&ag, a, v);
        cout << "Ho trovato " << x << " resort con tale attivita`:" << endl;
        for(int i=0; i<x; i++)
          stampaResort(v[i]);
        break;
      case '4':
        stampaOrd(&ag);
        break;
      case '5':
        cout << "Inserisci il nome del resort: ";
        cin >> n;
        cout << "Per quante persone? ";
        cin >> x;
        ris = prenota(&ag, n, x);
        if(ris) cout << "Ho prenotato" << endl;
        else cout << "Non ho prenotato" << endl;
        break;
      case '6':
        return 0;
    }
  }
}
