#include <fstream>
#include <cstring>
#include <iostream>
using namespace std;

const int MAXP = 10;
const int MAXA = 5;
const int MAXS = 100;
const int MAXR = 30;

enum Attivita {TENNIS, CALCIO, WINDSURF, BALLO, PALESTRA};

struct Resort {
  char nome[MAXS];
  char luogo[MAXS];
  Attivita att[MAXA];
  int quanteAtt;
  float costoAdulto;
  float costoBambino;
  int etaMaxBambino;
  int disponibilita;
};

struct Richiesta {
  int quanteP;
  int eta[MAXP];
  float budget;
  char luogo[MAXS];
};

struct AgenziaViaggi {
  Resort resorts[MAXR];
  int quanti;
};

void stampaResort(Resort r);

int carica(AgenziaViaggi* pa, const char fn[]) {
  Resort r;
  fstream f;
  f.open(fn, ios::in);
  if(!f)
    return -1;
  char attiv[MAXA];
  while(f >> r.nome >> r.luogo >> attiv >> r.costoAdulto >> r.costoBambino >> r.etaMaxBambino >> r.disponibilita){
    int l = strlen(attiv);
    for(int i=0; i<l; i++)
      switch(attiv[i]) {
        case 't': r.att[i] = TENNIS;
            break;
        case 'c': r.att[i] = CALCIO;
            break;
        case 'w': r.att[i] = WINDSURF;
            break;
        case 'b': r.att[i] = BALLO;
            break;
        case 'p': r.att[i] = PALESTRA;
            break;
      }
    r.quanteAtt = l;
    pa->resorts[pa->quanti++] = r;
  }
  return pa->quanti; 
}

bool compatibile(Resort res, Richiesta ric) {
  if(ric.quanteP > res.disponibilita)
    return false;
  int qb = 0;
  for(int i=0; i<ric.quanteP; i++)
    if(ric.eta[i]<=res.etaMaxBambino)
      qb++;
  if(ric.budget < qb*res.costoBambino + (ric.quanteP - qb) *res.costoAdulto)
    return false;
  if(strcmp(ric.luogo, res.luogo) != 0)
    return false;
  return true;
}

void stampaResortCompatibili(const AgenziaViaggi* pa, Richiesta r) {
  for(int i=0; i<pa->quanti; i++)
    if(compatibile(pa->resorts[i], r))
      stampaResort(pa->resorts[i]);
}

bool haAttivita(Resort r, Attivita a) {
  for(int i=0; i<r.quanteAtt; i++)
    if(r.att[i] == a)
      return true;
  return false;
}

int cercaPerAttivita(const AgenziaViaggi* pa, Attivita a, Resort vett[]) {
  int conta = 0;
  for(int i=0; i<pa->quanti; i++)
    if(haAttivita(pa->resorts[i], a))
      vett[conta++] = pa->resorts[i];
  return conta;
}

void ordina(AgenziaViaggi* pa) {
  int index;
  for(int i=0; i<pa->quanti-1; i++) {
    index = i;
    for(int j=i; j<pa->quanti; j++)
      if(pa->resorts[index].costoAdulto > pa->resorts[j].costoAdulto)
        index = j;
    Resort tmp = pa->resorts[i];
    pa->resorts[i] = pa->resorts[index];
    pa->resorts[index] = tmp;
  }
}

void stampaOrd(const AgenziaViaggi* pa) {
  AgenziaViaggi aux = *pa;
  ordina(&aux);
  for(int i=0; i<aux.quanti; i++) 
    stampaResort(aux.resorts[i]); 
}

bool prenota(AgenziaViaggi* pa, const char n[], int q) {
  bool prenotato = false;
  for(int i=0; i<pa->quanti; i++)
    if(strcmp(pa->resorts[i].nome, n) == 0){
      if(pa->resorts[i].disponibilita >= q) {
        pa->resorts[i].disponibilita -= q;
        prenotato = true;
        if(pa->resorts[i].disponibilita == 0)
          pa->resorts[i] = pa->resorts[--pa->quanti];
      }
      break;
    }
  return prenotato;
}

